#pragma comment(linker, "/STACK:104857600")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cassert>

using namespace std;

int seed, n, k, cnt;
float branch_probability = 1;

void dfs(int u)
{
	if (cnt >= n) return;
	int c = abs(rand()) % (k + 1);
	for (int i = 0; i < c && cnt < n; i++) {
		if (rand() / float(RAND_MAX) > branch_probability) continue;
		cout << u << ' ';
		dfs(++cnt);
	}
}

int main(int argc, char **argv)
{
	assert(argc >= 4 && argc <= 5);
	freopen("input.txt", "w", stdout);

	sscanf(argv[1], "%d", &seed);
	sscanf(argv[2], "%d", &n);
	sscanf(argv[3], "%d", &k);
	if (argc == 5)
		sscanf(argv[4], "%g", &branch_probability);

	srand(seed);

	cout << n << ' ' << k << endl;
	while (cnt < n)
		dfs(cnt);

	return 0;
}